import { h } from '@stencil/core';
import merge from 'lodash/merge';
const parseStyles = styles => styles
    .split(';')
    .filter(style => style.split(':')[0] && style.split(':')[1])
    .map(style => [
    style.split(':')[0].trim().replace(/-./g, c => c.substr(1).toUpperCase()),
    style.split(':')[1].trim()
])
    .reduce((styleObj, style) => (Object.assign(Object.assign({}, styleObj), { [style[0]]: style[1] })), {});
// tslint:disable-next-line: variable-name
export const SVGContent = ({ elements, extra }) => {
    return elements.map(el => {
        // Copy attributes, since they're going to be modified.  If the original
        // attributes are referenced, then any modifications are lasting.
        let attrs = Object.assign({}, el.attrs);
        if (attrs.hasOwnProperty('xlink:href')) {
            attrs['xlinkHref'] = attrs['xlink:href'];
            delete attrs['xlink:href'];
        }
        if (extra !== undefined && extra.hasOwnProperty(el.attrs.id)) {
            // Attrs can have properties that are objects (class and style), so do
            // a deep merge when adding any extra attributes.
            attrs = merge(attrs, extra[el.attrs.id]);
        }
        if (attrs.hasOwnProperty('style') && typeof attrs.style === 'string') {
            attrs.style = parseStyles(attrs.style);
        }
        return (h(el.elem, Object.assign({}, attrs), el.content ?
            el.content.map(content => (content.text)) : undefined));
    });
};
