import { r as registerInstance, h, f as Host } from './index-ebe1bf1f.js';

const textLogCss = "";

const RLTextLog = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.strings = [];
    }
    /**
     * Add a new line to the log.
     * @param str A string to write to the log
     */
    async log(str = '') {
        this.strings = [...this.strings, str];
    }
    hostData() {
        return {
            class: {
                'rl-text-log': true,
            }
        };
    }
    __stencil_render() {
        return this.strings.map(s => h("div", null, s));
    }
    render() { return h(Host, this.hostData(), this.__stencil_render()); }
};
RLTextLog.style = textLogCss;

export { RLTextLog as rl_text_log };
