import { Coordinate } from '../utils/coordinate';
interface Size {
    height: number;
    width: number;
}
/**
 * An image displayed as the icon of a `MapMarker`.
 */
export declare class MarkerIcon {
    _anchor: Coordinate;
    /**
     * The position of the icon relative to the marker.
     */
    set anchor(c: Coordinate);
    get anchor(): Coordinate;
    _originalSize: {
        width: number;
        height: number;
    };
    /**
     * The natural size of the image without any scaling.
     */
    set originalSize(s: Size);
    get originalSize(): Size;
    _size: Size;
    /**
     * The size of the image after scaling.
     */
    set size(s: Size);
    get size(): Size;
    _scale: number;
    /**
     * The factor by which to scale the image.
     */
    set scale(s: number);
    get scale(): number;
    _url: string;
    /**
     * The URL of the image.
     */
    set url(url: string);
    get url(): string;
    /**
     * Renders the DOM necessary to display the icon.
     */
    render(): any;
}
export {};
